// C Source File
// Created 7/16/00; 3:30:45 PM
// Release 2
// This is the code for the ASM version - the BASIC version doesn't
// include vat.h or the lines starting with SymFindPtr (they are
// unecessary and wouldn't work all the time anyway).

#define RETURN_VALUE dat // Redirect Return Value

#include <nostub.h>  // Make NoStub Program
#include <estack.h>  // Support Expression Stack
#include <args.h>    // Argument passing
#include <events.h>  // Event handling
#include <alloc.h>   // for HeapDeref function
#include <string.h>  // for strcpy function
#include <vat.h>     // for SymFindPtr and Sym_Entry structure

int _ti89;           // Produce .89Z File

char * var = "                    "; // buffer for variable name string


// Event Handler for capturing the user's choice from the Var-Link dialog
void Handler(EVENT* ev)
{
	strcpy(var,HeapDeref(ev->extra.hPasteText));
	EV_defaultHandler(ev);
};

// Main Function
void _main()
{
	EVENT keyp;
	SymFindPtr($(varlink),0)->flags.bits.hidden = 1;  //hide this program so the user can't delete it while its running
	*var = '\0';
	EV_captureEvents(Handler);  // install my event handler
	keyp.Type = CM_KEYPRESS;    // make Var-Link keypress
	keyp.extra.Key.Code = 4141; //
	EV_defaultHandler(&keyp);   // open Var-Link
	push_ANSI_string(var);      // Var-Link is now closed, Handler has set var to user's choice
	EV_captureEvents(NULL);     // re-install previous handler
	SymFindPtr($(varlink),0)->flags.bits.hidden = 0;  // unhide this program so the user can see it after it exits
}
